Stage (GNU cryptographic primitives and tools)
Keywords: gnu.crypto.assembly.Stage,Stage class

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## gnu.crypto.assembly
Class Stage

    java.lang.Object
      |
      +--gnu.crypto.assembly.Stage

public abstract class Stage
extends java.lang.Object

A Stage in a Cascade Cipher.

Each stage may be either an implementation of a Block Cipher Mode of Operation (`IMode`) or another Cascade Cipher (`Cascade`). Each stage has also a natural operational direction when constructed for inclusion within a `Cascade`. This natural direction dictates how data flows from one stage into another when stages are chained together in a cascade. One can think of a stage and its natural direction as the specification of how to wire the stage into the chain. The following diagrams may help understand the paradigme. The first shows two stages chained each with a `Direction.FORWARD` direction.

               FORWARD         FORWARD
           +------+       +-------+
           |      |       |       |
           |  +--in --+   |   +--in --+
        ---+  | Stage |   |   | Stage |  +---
              +--out--+   |   +--out--+  |
                  |       |       |      |
                  +-------+       +------+

The second diagram shows two stages, one in a `Direction.FORWARD` direction, while the other is wired in a `Direction.REVERSED` direction.

               FORWARD         REVERSED
           +------+               +------+
           |      |               |      |
           |  +--in --+       +--in --+  |
        ---+  | Stage |       | Stage |  +---
              +--out--+       +--out--+
                  |               |
                  +---------------+

See Also:
  `ModeStage`, `CascadeStage`

Field Summary
`static java.lang.String` | `DIRECTION`
`protected Direction` | `forward`
`protected Direction` | `wired`

Constructor Summary
`protected` | `Stage(Direction forwardDirection)`

Method Summary
`abstract java.util.Set` | `blockSizes()` Returns the `Set` of supported block sizes for this `Stage`.
`abstract int` | `currentBlockSize()` Returns the currently set block size for the stage.
`static Stage` | `getInstance(Cascade cascade, Direction forwardDirection)`
`static Stage` | `getInstance(IMode mode, Direction forwardDirection)`
`void` | `init(java.util.Map attributes)` Initialises the stage for operation with specific characteristics.
`void` | `reset()` Resets the stage for re-initialisation and use with other characteristics.
`abstract boolean` | `selfTest()` Conducts a simple correctness test that consists of basic symmetric encryption / decryption test(s) for all supported block and key sizes of underlying block cipher(s) wrapped by Mode leafs.
`void` | `update(byte[] in, int inOffset, byte[] out, int outOffset)` Processes exactly one block of plaintext (if initialised in the `Direction.FORWARD` state) or ciphertext (if initialised in the `Direction.REVERSED` state).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DIRECTION

    public static final java.lang.String DIRECTION

See Also:
  Constant Field Values

### forward

    protected Direction forward

### wired

    protected Direction wired

Constructor Detail

### Stage

    protected Stage(Direction forwardDirection)

Method Detail

### getInstance

    public static final Stage getInstance(IMode mode,
                                          Direction forwardDirection)

### getInstance

    public static final Stage getInstance(Cascade cascade,
                                          Direction forwardDirection)

### blockSizes

    public abstract java.util.Set blockSizes()

  Returns the `Set` of supported block sizes for this `Stage`. Each element in the returned `Set` is an instance of `Integer`.

  Returns:
    a `Set` of supported block sizes.

### init

    public void init(java.util.Map attributes)
              throws java.security.InvalidKeyException

  Initialises the stage for operation with specific characteristics.

  Parameters:
    `attributes` - a set of name-value pairs that describes the desired future behaviour of this instance.
  Throws:
    `java.lang.IllegalStateException` - if the instance is already initialised.
    `java.security.InvalidKeyException` - if the key data is invalid.

### currentBlockSize

    public abstract int currentBlockSize()
                                  throws java.lang.IllegalStateException

  Returns the currently set block size for the stage.

  Returns:
    the current block size for this stage.
  Throws:
    `java.lang.IllegalStateException` - if the instance is not initialised.

### reset

    public void reset()

  Resets the stage for re-initialisation and use with other characteristics. This method always succeeds.

### update

    public void update(byte[] in,
                       int inOffset,
                       byte[] out,
                       int outOffset)

  Processes exactly one block of plaintext (if initialised in the `Direction.FORWARD` state) or ciphertext (if initialised in the `Direction.REVERSED` state).

  Parameters:
    `in` - the plaintext.
    `inOffset` - index of `in` from which to start considering data.
    `out` - the ciphertext.
    `outOffset` - index of `out` from which to store result.
  Throws:
    `java.lang.IllegalStateException` - if the instance is not initialised.

### selfTest

    public abstract boolean selfTest()

  Conducts a simple correctness test that consists of basic symmetric encryption / decryption test(s) for all supported block and key sizes of underlying block cipher(s) wrapped by Mode leafs. The test also includes one (1) variable key Known Answer Test (KAT) for each block cipher.

  Returns:
    `true` if the implementation passes simple correctness tests. Returns `false` otherwise.

Overview | Package | Class | Tree | Serialized | Deprecated | Index | Help
| For the latest news and information visit The GNU Crypto project
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001, 2002, 2003, 2004 Free Software Foundation, Inc.